SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:13'!
answerSeventeen

	self export: true.
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: 16).! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:15'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/4/2008 13:44'!
svnAdd

	| targetStringObj target targetLength tmpString report |
	self export: true.
	self var: #target declareC: 'char *target'.
	self var: #tmpString declareC: 'char* tmpString'.
	self var: #report declareC: 'FILE* report'.
	targetStringObj := interpreterProxy stackValue: 0. 
	targetLength := interpreterProxy slotSizeOf: targetStringObj.
	
	tmpString := interpreterProxy firstIndexableField: targetStringObj.
	self cCode: 'target = (char*) malloc(targetLength + 1)'.
	self cCode: 'report = fopen("report.txt", "a")'.
	0 to: targetLength -1 do: [:stringIndex |
		target at: stringIndex put: (tmpString at: stringIndex)].
	self cCode: 'target[targetLength] = ''\0'''.
	self cCode: 'fprintf(report, "%s\n", target)'.
	
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"
	
	self cCode: 'free(target)'.
	self cCode: 'fclose(report)'.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 2/3/2008 06:07'!
svnCommit

	| targetsObj targetsArray squeakStrings count cString stringSize tmpString |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targetsArray declareC: 'char** targetsArray'.
	self var: #cString declareC: 'char* cString'.
	self var: #tmpString declareC: 'char* tmpString'.
	
	targetsObj := interpreterProxy stackValue: 0.
	squeakStrings := interpreterProxy firstIndexableField: targetsObj.
	count := interpreterProxy slotSizeOf: targetsObj.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	0 to: count - 1 do: [:listIndex |
		stringSize := interpreterProxy slotSizeOf: (squeakStrings at: listIndex).
		tmpString := interpreterProxy firstIndexableField: (squeakStrings at: listIndex).
		self cCode: 'cString = (char*) malloc(stringSize + 1)'.
		0 to: stringSize -1 do: [:stringIndex |
			cString at: stringIndex put: (tmpString at: stringIndex)].
		self cCode: 'cString[stringSize] = ''\0'''.
		targetsArray at: listIndex put: cString].
	
	self cCode: 'commit( count, targetsArray )'.

	0 to: count - 1 do: [:listIndex |
		self cCode: 'free( targetsArray[listIndex] )'].
	self cCode: 'free( targetsArray )'.! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 14:28'!
writeString

	| stringObj stringPtr |
	self export: true.
	self var: #stringObj declareC: 'int stringObj'. 
	self var: #stringPtr declareC: 'char *stringPtr'.
	stringObj := interpreterProxy stackValue: 0. 
	stringPtr := self 
		cCoerce: (interpreterProxy arrayValueOf: stringObj) 
		to: 'char *'.! !
